#include <stdio.h>
#include <math.h>
#include "main.h"

/********************************************************/
/*** Function to perform the simulated annealing step ***/
/********************************************************/

void anneal(FILE *results, long int seeda, long int seedb) {
  
  double ubeta, co, prev_prev_lik;
  double lik_change, max_change=0.0;

  setall(seeda,seedb);
  
  fprintf(results,"\n\n>>> STEM: Species Tree Estimation using Maximum likelihood <<<\n\n");

  co=(-previous_lik)*0.25;
  counteri=1;
  ubeta = 0.001;
  ci=co/(1+counteri*ubeta);

  /**  estimate U, the upper bound on the change in ln L  **/

  printf("  Beginning burn-in ....");
  fflush(0);
  
  while (counteri<burnin) { 
    prev_prev_lik = previous_lik;
    trbldg(results);
    counteri++;
    ci = co/(1+counteri*ubeta);
    lik_change = fabs(previous_lik - prev_prev_lik);
    if (lik_change>max_change) max_change=lik_change;
  }
  done_burnin = 1;

  printf(" complete.\n\n");


   /**  reset to start at beginning values  **/

  /*fprintf(results," The likelihood at end of burnin is %f\n\n",previous_lik);
  fprintf(results," After burnin, tree and branch lengths are:\n");
  for (k=0; k<ntaxa-1; k++) fprintf(results,"%d %d\n",ppTwoRow[0][k],ppTwoRow[1][k]);
  for (k=1; k<2*ntaxa; k++) fprintf(results,"%f\n",TimeVec[k]);*/

  co=max_change;
  counteri = 0;

  fprintf(results,">> The maximum change in the log likelihood observed during burnin is %f\n",max_change);
  fprintf(results,">> c_0 will be set to %f.\n",max_change);

 /**  simulated annealing  **/

  printf("  Beginning tree search ....");
  fflush(0);

  while (no_last_un<bound_last_un && counteri<bound_total_iter) {

    /*printf("\n ******** Iteration %d **********\n",counteri);*/
    trbldg(results);
    counteri++;
    ci = co/(1.0+counteri*beta);
    /*printf("componenets to ci %f counteri %d co %f beta %f\n",ci,counteri,co,beta);*/
    if (verbose == 1) printf("anneal %d %f\n",counteri,previous_lik); 

  }

  fprintf(results,">> %d iterations were performed before the stopping rule was satisfied.\n",counteri);

  printf(" complete.\n\n");

}
